<?php
    
	    class gaController extends ga {

	        function init() 
	        {
				$template_path = sprintf("%sskins/%s/",$this->module_path, $this->module_info->skin);
	            if(!is_dir($template_path)||!$this->module_info->skin) {
	                $this->module_info->skin = 'default';
	                $template_path = sprintf("%sskins/%s/",$this->module_path, $this->module_info->skin);
	            }
	            $this->setTemplatePath($template_path);
			}
			
			
	        function procGaAjaxTemplate() 
	        {
				
				$oTemplate = &TemplateHandler::getInstance();
			    $templatePath = $this->getTemplatePath(); 
			    $page = $oTemplate->compile($templatePath, 'template');
				
				$args = new stdClass;
				$outputGa = executeQuery("ga.getGa", $args);
				$regdate = $outputGa->data->regdate;
				$cache_time = $outputGa->data->cache_time > 60 ? $outputGa->data->cache_time * 60 : 3600;
				
				
				// Install
				if($regdate == "")
				{
					// Path
					if(!$this->module_info->skin = 'default') $this->module_info->skin = "default";
					
					$AuthConfig = file_get_contents(__DIR__ . "/skins/". $this->module_info->skin ."/js/client.json");
					$setAuthConfig = json_decode($AuthConfig, true);	  
					$getAccessedUrl = $setAuthConfig['web']['redirect_uris'];
				
					$state = urlencode(Context::get('url'));
					$url = "https://accounts.google.com/o/oauth2/auth?response_type=code&scope=https://www.googleapis.com/auth/analytics.readonly&access_type=offline&approval_prompt=force&client_id=353266657989-jfoq48lh3fqf69jqugf0amvfah9946hv.apps.googleusercontent.com&redirect_uri=" . $getAccessedUrl . "&state=" . $state;
					$this->add('url', $url);
					return false;
				}
				
				// Cache
				if($regdate !== ""  && $regdate + $cache_time > time() && !$_GET['refresh_token'] && $outputGa->data->data !== "")
				{
					
					$this->add('cache', stripcslashes($outputGa->data->data));
					return false;
				}
				
				$access_token = $outputGa->data->access_token;
				$site_id = $outputGa->data->site_id;
				$page_cnt = isset($outputGa->data->page_cnt) && $outputGa->data->page_cnt > 100 ? $outputGa->data->page_cnt : 100; // 무조건 100이상
				
				// Get Data
				$analytics = $this->procGetAnalytics($access_token);
				$today_data = $this->procGa($analytics, $site_id, "today", "today", "ga:pageviews,ga:avgTimeOnPage,ga:adsenseRevenue,ga:adsenseAdsClicks,ga:adsenseCTR", "ga:pagePath,ga:pageTitle", "-ga:adsenseRevenue",'',  100);	
				$month_data = $this->procGa($analytics, $site_id, "65daysAgo", "today", "ga:adsenseRevenue", "ga:date", 'ga:date', '', $page_cnt);	
				$month_age = $this->procGa($analytics, $site_id, "30daysAgo", "today", "ga:sessions", "ga:userAgeBracket, ga:userGender", '', '', 100);	
				 
				if(strpos($today_data['error']['message'], 'Restricted metric(s)') !== false) 
				{
					$args = new stdClass();
					$args->data = null;
					$output = executeQuery('ga.updateGa', $args);  
				    $error_msg = "애널리틱스에 애드센스를 연결해주세요.";
				}
				
				// Chart - Revenue
				$graphRevenue = $this->procGaGraphRevenue($month_data);
				$thisMonthRevenue =  $graphRevenue['thisMonthRevenue'];
				$month_day =  $graphRevenue['month_day'];
				$month_revenue_day = $graphRevenue['month_revenue_day'];
				
				// Chart - Age, Gender
				$totalAge = $month_age->totalsForAllResults['ga:sessions'];
				$graphAgeGender = $this->procGaChartAgeGender($month_age);
				$ghtml = $graphAgeGender['ghtml'];
				$maleHtml = $graphAgeGender['maleHtml'];
				$femaleHtml = $graphAgeGender['femaleHtml'];
				$totalHtml = $graphAgeGender['totalHtml'];
				$this->add('piechartdata', $ghtml);
				$this->add('maleHtml', $maleHtml);
				$this->add('femaleHtml', $femaleHtml);
				$this->add('totalHtml', $totalHtml);
				
				// Month Earning
				$month_earning = isset($thisMonthRevenue) ? "$ " . round($thisMonthRevenue,3) : "0";
				$this->add('month_earning', $month_earning);
				
				// Today Earning
				$today_earning = isset($today_data->totalsForAllResults['ga:adsenseRevenue']) ? "$ " . round($today_data->totalsForAllResults['ga:adsenseRevenue'], 3) : "No data";
				$this->add('today_earning', $today_earning);
				
				// Today Pageview
				$today_pv = isset($today_data->totalsForAllResults['ga:pageviews']) ? $today_data->totalsForAllResults['ga:pageviews'] : "No data";
				$this->add('pv', $today_pv);
				 
				// Avg on page
				$avgonpage = isset($today_data->totalsForAllResults['ga:avgTimeOnPage']) ? round($today_data->totalsForAllResults['ga:avgTimeOnPage'], 3) . " s" : "No data";
				$this->add('avgonpage', $avgonpage);
				
				// Cpc
				$today_cpc = isset($today_data->totalsForAllResults['ga:adsenseRevenue']) && $today_data->totalsForAllResults['ga:adsenseAdsClicks'] > 0 ? "$ ".round($today_data->totalsForAllResults['ga:adsenseRevenue']/$today_data->totalsForAllResults['ga:adsenseAdsClicks'],3) : "No data";
	            $this->add('cpc', $today_cpc);    
				
				// Clicks
				$today_click = isset($today_data->totalsForAllResults['ga:adsenseAdsClicks']) ? round($today_data->totalsForAllResults['ga:adsenseAdsClicks'],2) : "No data";
	            $this->add('clicks', $today_click);   
	            
				// Ctr
				$today_ctr = isset($today_data->totalsForAllResults['ga:adsenseAdsClicks']) ? round(($today_data->totalsForAllResults['ga:adsenseAdsClicks']/$today_data->totalsForAllResults['ga:pageviews'])*100,2) : "No data";
				$this->add('ctr', $today_ctr);
	            
				// RPM
				$today_rpm = isset($today_data->totalsForAllResults['ga:adsenseRevenue']) ? round(($today_data->totalsForAllResults['ga:adsenseRevenue']/$today_data->totalsForAllResults['ga:pageviews'])*1000,2) : "No data";
				$this->add('rpm', $today_rpm);    
	                
				// Graph per day
				$this->add('month_day', $month_day);
				$this->add('month_revenue_day', $month_revenue_day);
				
				// Table
				$table = $this->porcGaTablePage($today_data);
				$this->add('table', $table);
				
				// Table foot
				$tableFoot = $this->porcGaTablePageFoot($today_data);
				$this->add('tablefoot', $tableFoot);
				
				// Table List Count
				$this->add('page_cnt', $page_cnt);
				
				// return page
				$this->add('page', $page);
				
				// Update for cache
				$args = new stdClass();
				$args->regdate = time();
				$output = executeQuery('ga.updateGa', $args);  
				
	        }
			
			// Graph - Revenue
			function procGaGraphRevenue($month_data) 
			{
				if(isset($month_data))
				{
					$thisMonthRevenue = 0;
					$month_day = $month_revenue_day = "";
					foreach($month_data->rows as $item)
					{
						
						// This month
						$year = substr($item[0], 0, 4);
						$month = substr($item[0], 4, 2);
						$day = substr($item[0], -2);
						if(date("m") == $month)
						{
							$thisMonthRevenue += $item[1];
						}
						
						// Graph
						$prev_month = strtotime("-1 month", time());
						$prev_m = date("Ymd", $prev_month);
						if($prev_m < $item[0])
						{
							$month_day .= '"' . substr($item[0], -2) . '"' . ",";
							$month_revenue_day .= round($item[1], 2) . ",";
						}
					}
				}
				
				$month_day =  "[".substr($month_day, 0, -1) . "]";
				$month_revenue_day = "[".substr($month_revenue_day, 0, -1) . "]";
				
				return array("thisMonthRevenue" => $thisMonthRevenue,"month_day" => $month_day, "month_revenue_day" => $month_revenue_day);
			}	
			
			
			function procGaUpdateCache() 
			{
				
				$html = Context::get('html');
				$args = new stdClass();
				$args->data = addslashes($html);
				$output = executeQuery('ga.updateGa', $args);
				
			}
			
			// Table Page 
			function porcGaTablePage($today_data) 
			{
				$pageList = "";
				if(isset($today_data))
				{
					foreach($today_data->rows as $item)
					{
						$cpc = $item[5] > 0 ? round($item[4] / $item[5], 3) : "0";
						$pageList .= "<tr>";
						$pageList .= '<td><a href="//' . $_SERVER['HTTP_HOST'] .$item[0] .'" target="_blank">' . $item[1] . '</td>';
						$pageList .= '<td>' . round($item[2],2) . '</td>';
						$pageList .= '<td>' . round($item[3],2) . '</td>';
						$pageList .= '<td>' . round($item[4],3) . '</td>';
						$pageList .= '<td>' . $cpc . '</td>';
						$pageList .= '<td>' . $item[5] . '</tdd>';
						$pageList .= '<td class="btnGender">남녀비율</td>';
						$pageList .= '<td class="btnAge">연령대</td>';
						$pageList .= "</tr>";
					}
					
				}
				return $pageList;
			}
			
			// Table Foot 
			function porcGaTablePageFoot($today_data) 
			{
				$tableFoot = "";
				$tableFoot .= "<th>Total</th>";
				$tableFoot .= "<th>" .$today_data->totalsForAllResults['ga:pageviews'] ."</th>";
				$tableFoot .= "<th>" . round($today_data->totalsForAllResults['ga:avgTimeOnPage'], 3) ."</th>";
				$tableFoot .= "<th>" . round($today_data->totalsForAllResults['ga:adsenseRevenue'], 3) ."</th>";
				$tableFoot .= "<th>" . round($today_data->totalsForAllResults['ga:adsenseRevenue']/$today_data->totalsForAllResults['ga:adsenseAdsClicks'], 3) ."</th>";
				$tableFoot .= "<th>" .$today_data->totalsForAllResults['ga:adsenseAdsClicks'] ."</th>";
				$tableFoot .= "<th></th>";
				$tableFoot .= "<th></th>";
				
				return $tableFoot;
			}
			
			
			function procGa($analytics, $site_id, $startDate, $endDate, $metrics, $dimensions, $sort = false, $filter = false, $cnt = false)
			{
				
				
				$pvData = $this->procGaApi($analytics, $site_id, $startDate, $endDate, $metrics, $dimensions, $sort, '', $cnt);
				
		
				if($pvData['error']['code'] == "401")
				{
					
					$access_token = $this->porcGaSaveAccessToken();
					$analytics = $this->procGetAnalytics($access_token);
					$pvData = $this->procGaApi($analytics, $site_id, $startDate, $endDate, $metrics, $dimensions, $sort, '', $cnt);
				}
				
				return $pvData;
			}	
			
			function porcGaSaveAccessToken() 
			{
				$access = json_decode($this->procGetAccessToken(), true);
				$access_token = $access['access_token'];
				
				$args = new stdClass();
				$args->access_token = $access_token;
				$output = executeQuery('ga.updateGa', $args);
		
				return $access_token;
			}		
			
			function procGaApi( $analytics, $site_id, $startDate, $endDate, $metrics, $dimensions = false, $sort = false, $filter = false, $maxresult = false, $name = ''  ) 
			{
				$ids = 'ga:'.$site_id; 
			
				$optParams = array();
				$optParams['dimensions'] = $dimensions;
				if($sort) $optParams['sort'] = $sort;
				if($maxresult) $optParams['max-results'] = $maxresult;
				if($filter) $optParams['filters'] = $filter;
				
				try {
			        $results = $analytics->data_ga->get($ids, $startDate, $endDate, $metrics, $optParams);
			    }
			    catch (Exception $e) {
			         $results =  json_decode($e->getMessage(), true);
			    }
				
			 	return $results;
			
			}

			// Install
	        function procGaInstall() 
	        {
				
				if($_GET['refresh_token'])
				{
					
					
					$args = new stdClass;
					$outputGa = executeQuery("ga.getGa", $args);
					if(!$outputGa->data->refresh_token)
					{
						// Refresh token save
						$refresh_token =  $_GET['refresh_token'];
						
						$accessTokenJson = $this->procGetAccessToken($refresh_token);
						$accessToken = json_decode($accessTokenJson, true);
						$access_token = $accessToken['access_token'];
						
						$analytics = $this->procGetAnalytics($access_token);
						$site_id = $this->procGaGetSiteId($analytics);
						if(!$site_id) 
						{
							$msg = "애널리틱스에 현재 사이트가 추가되어 있지 않습니다.";
							echo '<script>alert(' . $msg . ');</script>';
						}
				
						$args = new stdClass();
						$args->refresh_token = $refresh_token;
						$args->regdate = time();
						$args->access_token = $access_token;
						$args->site_id = $site_id;
						$output = executeQuery('ga.insertGa', $args);
					}
					
				}	
				
							
	        }

			// Site_id
			function procGaGetSiteId($analytics)
			{
					$site_id = "";
					$accounts = $analytics->management_accounts->listManagementAccounts();
			
					
					if (count($accounts->getItems()) > 0) 
					{
						$items = $accounts->getItems();
						$firstAccountId = $items[0]->getId();
						
					
						// Get the list of properties for the authorized user.
						$properties = $analytics->management_webproperties->listManagementWebproperties($firstAccountId);
						
						if (count($properties->getItems()) > 0) 
						{
						      $items = $properties->getItems();
						      $firstPropertyId = $items[0]->getId();
						
						      // Get the list of views (profiles) for the authorized user.
						      $profiles = $analytics->management_profiles->listManagementProfiles($firstAccountId, $firstPropertyId);
					
						      if (count($profiles->getItems()) > 0) 
						      {
						      	
						        $items = $profiles->getItems();
								
								foreach($items as $item)
								{
									$domain_scheme = $this->parseURL($_SERVER['HTTP_HOST']);
									if(strpos($item->websiteUrl, $domain_scheme['domain']) !== false)
									{
										$site_id = $item->getId();
									}
								}
						      }
							
						}
					}		
					
					return $site_id;
			}

			function procGetAnalytics($access_token)
			{
				if(!$this->module_info->skin = 'default') $this->module_info->skin = "default";
				
				$client = new Google_Client();
				$client->setAuthConfig(__DIR__ . "/skins/". $this->module_info->skin ."/js/client.json");
				$client->addScope(Google_Service_Analytics::ANALYTICS_READONLY);
				$client->setAccessToken($access_token);
				$analytics = new Google_Service_Analytics($client);
			
				
				return $analytics;
			}

			function procGetAccessToken($refresh_token = false)
			{
				
				if(!$refresh_token)
				{
					$args = new stdClass;
					$outputGa = executeQuery("ga.getGa", $args);
					$refresh_token = $outputGa->data->refresh_token;
				}
				
				if(!$this->module_info->skin = 'default') $this->module_info->skin = "default";
				$AuthConfig = file_get_contents(__DIR__ . "/skins/". $this->module_info->skin ."/js/client.json");
				$setAuthConfig = json_decode($AuthConfig, true);	  
			
				$url = "https://www.googleapis.com/oauth2/v4/token";
				$client_id = $setAuthConfig['web']['client_id'];
				$client_secret = $setAuthConfig['web']['client_secret'];
				
				$param = array(
				    'client_id'   => $client_id,
				    'client_secret'   => $client_secret,
				    'refresh_token' => $refresh_token,
				    'grant_type' => 'refresh_token'
				);
				
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $url);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($param));
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
				$result = curl_exec($ch);
				curl_close($ch);
				
				return $result;
			}

			
			function procGaChartAgeGender($month_age) 
			{
				$totalAge = $month_age->totalsForAllResults['ga:sessions'];
				if(isset($totalAge) && $totalAge > 0)
				{
					$ghtml = "";
					$gMale = 0;
					$gFemale = 0;
					
					$ahtml = "";
					$aMaleTotal = 0;
					$aFemaleTotal = 0;
					
					// Gender
					foreach($month_age->rows as $item)
					{
						
						if($item[1] == "female")
						{
							$gFemale += $item[2];
							//
						} else if($item[1] == "male") {
							$gMale += $item[2];
						}
					}
					$ghtml .= '<div class="male">' . round($gMale/$totalAge * 100). '</div>';
					$ghtml .= '<div class="female">' . round($gFemale/$totalAge * 100). '</div>';
					
					// Age
					foreach($month_age->rows as $item)
					{
						if($item[0] == "18-24")
						{
							if($item[1] == "male")
							{
								$aMaleTotal += $item[2];
								$aTotal['male'][0] = $item[2];
							} else if($item[1] == "female") {
								$aFemaleTotal += $item[2];
								$aTotal['female'][0] = $item[2];
							}
							
						} else if($item[0] == "25-34") {
							
							if($item[1] == "male")
							{
								$aMaleTotal += $item[2];
								$aTotal['male'][1] = $item[2];
							} else if($item[1] == "female") {
								$aFemaleTotal += $item[2];
								$aTotal['female'][1] = $item[2];
							}
							
						} else if($item[0] == "35-44") {
							
							if($item[1] == "male")
							{
								$aMaleTotal += $item[2];
								$aTotal['male'][2] = $item[2];
							} else if($item[1] == "female") {
								$aFemaleTotal += $item[2];
								$aTotal['female'][2] = $item[2];
							}
							
						} else if($item[0] == "45-54") {
							
							if($item[1] == "male")
							{
								$aMaleTotal += $item[2];
								$aTotal['male'][3] = $item[2];
							} else if($item[1] == "female") {
								$aFemaleTotal += $item[2];
								$aTotal['female'][3] = $item[2];
							}
							
						} else if($item[0] == "55-64") {
							
							if($item[1] == "male")
							{
								$aMaleTotal += $item[2];
								$aTotal['male'][4] = $item[2];
							} else if($item[1] == "female") {
								$aFemaleTotal += $item[2];
								$aTotal['female'][4] = $item[2];
							}
							
						} else if($item[0] == "65+") {
							
							if($item[1] == "male")
							{
								$aMaleTotal += $item[2];
								$aTotal['male'][5] = $item[2];
							} else if($item[1] == "female") {
								$aFemaleTotal += $item[2];
								$aTotal['female'][5] = $item[2];
							}
						}
					}
					
					$maleHtml = $femaleHtml = $totalHtml = "";
					for($i=0; $i<6; $i++)
					{
						$valueMale[$i] = isset($aTotal['male'][$i]) ? $aTotal['male'][$i] : 0;
						$valueFemale[$i] = isset($aTotal['female'][$i]) ? $aTotal['female'][$i] : 0;
				
						$maleHtml .=  round($valueMale[$i]/$aMaleTotal * 100) . ",";
						$femaleHtml .= round($valueFemale[$i]/$aFemaleTotal * 100) . ",";
						$totalHtml .= round(($valueMale[$i] + $valueFemale[$i]) / $totalAge * 100) . ",";
						
						
					}
					$maleHtml =  "[".substr($maleHtml, 0, -1) . "]";
					$femaleHtml = "[".substr($femaleHtml, 0, -1) . "]";
					$totalHtml = "[".substr($totalHtml, 0, -1) . "]";
				}
				
				return array("ghtml" => $ghtml, "maleHtml" => $maleHtml, "femaleHtml" => $femaleHtml, "totalHtml" => $totalHtml);
			}
			
			function procGaAjax()
			{
				// Get ajax
				$start_date = Context::get('start_date') == "" ? "today" : Context::get('start_date');
				$end_date = Context::get('end_date')== "" ? "today" : Context::get('end_date');
				$sort = Context::get('sort');
				$page_cnt = Context::get('page_cnt');
				
				// Get from database
				$args = new stdClass;
				$outputGa = executeQuery("ga.getGa", $args);
				$access_token = $outputGa->data->access_token;
				$site_id = $outputGa->data->site_id;
				
				// Get Data
				$analytics = $this->procGetAnalytics($access_token);
				
				// 남녀비율
				if($sort == 'gender')
				{
					
					$dimensions = 'ga:userGender,ga:pagePath';
					$metrics = 'ga:sessions';
					
					$data = $this->procGa($analytics, $site_id, $start_date, $end_date, $metrics, $dimensions);	
					
					$i = 0;
					$genderData = array();
					foreach($data->rows as $item)
					{
						
						$k = $i;	
						if($i == 0)
						{
							$genderData[0]['path'] = $item[1];
							
						} else {
							
							$isExist = $this->search2Array($genderData, 'path', $item[1]);
							
							if ($isExist === false) 
							{
								
								$genderData[$i]['path'] = $item[1];
						
							} else {
								$k = $isExist;
							}
						}
			
						if($item[0] == 'female')
						{
							$genderData[$k]['female'] = $item[2];
						} else if($item[0] == 'male'){
							$genderData[$k]['male'] = $item[2];
						}
						
						$i++;
					}
					
					$i=0;
					foreach($genderData as $item)
					{
						$genderResult[$i]['path'] = $item['path'];
						$genderResult[$i]['female'] = isset($item['female']) ? $item['female'] : "0.1";
						$genderResult[$i]['male'] = isset($item['male']) ? $item['male'] : "0.1";
						
						$total = $genderResult[$i]['female'] + $genderResult[$i]['male'];
						$genderResult[$i]['female'] = round($genderResult[$i]['female'] / $total *100, 0);
						$genderResult[$i]['male'] = round($genderResult[$i]['male'] / $total *100, 0);
						
						$i++; 
					}
					
					$this->add('ajaxdata', $genderResult);
					
				// Age
				} else if($sort == 'age') {
		
					$dimensions = 'ga:userAgeBracket,ga:pagePath';
					$metrics = 'ga:sessions';
					
					$data = $this->procGa($analytics, $site_id, $start_date, $end_date, $metrics, $dimensions);	
						
					$i = 0;
					$ageDataList = array();
					foreach($data->rows as $item)
					{
						
						
						$k = $i;	
						if($i == 0)
						{
							$ageData[0]['path'] = $item[1];
							
						} else {
							
							$isExist = $this->search2Array($ageData, 'path', $item[1]);
							
							
							if ($isExist === false) 
							{
								
								$ageData[$i]['path'] = $item[1];
								
							} else {
								$k = $isExist;
							}
						}
						
						
						if($item[0] == "18-24")
						{
							$ageData[$k]['session'][0] = $item[2];
							
						} else if($item[0] == "25-34") {
							
							$ageData[$k]['session'][1] = $item[2];
							
						} else if($item[0] == "35-44") {
							
							$ageData[$k]['session'][2] = $item[2];
							
						} else if($item[0] == "45-54") {
							
							$ageData[$k]['session'][3] = $item[2];
							
						} else if($item[0] == "55-64") {
							
							$ageData[$k]['session'][4] = $item[2];
							
						} else if($item[0] == "65+") {
							
							$ageData[$k]['session'][5] = $item[2];
							
						}
			
						$i++;
					}
					
					//배열 인덱스 재정렬  
					$i = 0;  
					foreach($ageData as $key=>$val)  
					{  
					    unset($ageData[$key]);  
					  
					    $new_key = $i;  
					    $ageData[$new_key] = $val;  
					  
					    $i++;  
					}  
			
			
					for($q=0; $q < count($ageData); $q++)
					{
						$ageData[$q]['total'] = 0;
						foreach($ageData[$q]['session'] as $item)
						{
							$ageData[$q]['total'] += $item;
						}
					}
					
					for($q=0; $q < count($ageData); $q++)
					{
						
						if(isset($ageData[$q]['session'][0]))
						{
							$ageData[$q]['percent'][0] = round($ageData[$q]['session'][0] / $ageData[$q]['total'] * 100, 0);
							$ageData[$q]['html'] .= "<div>18-24: ". $ageData[$q]['percent'][0] . "%</div>";
							
						} 
						if(isset($ageData[$q]['session'][1]))
						{
							
							$ageData[$q]['percent'][1] = round($ageData[$q]['session'][1] / $ageData[$q]['total'] * 100, 0);
							$ageData[$q]['html'] .= "<div>25-34: ". $ageData[$q]['percent'][1] . "%</div>";
						} 
						if(isset($ageData[$q]['session'][2]))
						{
						
							$ageData[$q]['percent'][2] = round($ageData[$q]['session'][2] / $ageData[$q]['total'] * 100, 0);
							$ageData[$q]['html'] .= "<div>35-44: ". $ageData[$q]['percent'][2] . "%</div>";
						} 
						if(isset($ageData[$q]['session'][3]))
						{
						
							$ageData[$q]['percent'][3] = round($ageData[$q]['session'][3] / $ageData[$q]['total'] * 100, 0);
							$ageData[$q]['html'] .= "<div>45-54: ". $ageData[$q]['percent'][3] . "%</div>";
						
						} 
						if(isset($ageData[$q]['session'][4]))
						{
						
							$ageData[$q]['percent'][4] = round($ageData[$q]['session'][4] / $ageData[$q]['total'] * 100, 0);
							$ageData[$q]['html'] .= "<div>55-64: ". $ageData[$q]['percent'][4] . "%</div>";
						} 
						if(isset($ageData[$q]['session'][5]))
						{
						
							$ageData[$q]['percent'][5] = round($ageData[$q]['session'][5] / $ageData[$q]['total'] * 100, 0);
							$ageData[$q]['html'] .= "<div>65+: ". $ageData[$q]['percent'][5] . "%</div>";
						}
						
					}
					
					
					for($i=0; $i < count($ageData); $i++)
					{
						
						unset($ageData[$i]['session']);
						unset($ageData[$i]['percent']);
						unset($ageData[$i]['total']);
					}
					
					$this->add('ajaxdata', $ageData);
					
				// Table		
				} else if($sort == 'table'){

					$today_data = $this->procGa($analytics, $site_id, $start_date, $end_date, "ga:pageviews,ga:avgTimeOnPage,ga:adsenseRevenue,ga:adsenseAdsClicks,ga:adsenseCTR", "ga:pagePath,ga:pageTitle", "-ga:adsenseRevenue",'',  $page_cnt);	
				
					$pageList = "";
					if(isset($today_data))
					{
						foreach($today_data->rows as $item)
						{
							$cpc = $item[5] > 0 ? round($item[4] / $item[5], 3) : "0";
							$pageList .= "<tr>";
							$pageList .= '<td><a href="//' . $_SERVER['HTTP_HOST'] .$item[0] .'" target="_blank">' . $item[1] . '</td>';
							$pageList .= '<td>' . round($item[2],2) . '</td>';
							$pageList .= '<td>' . round($item[3],2) . '</td>';
							$pageList .= '<td>' . round($item[4],3) . '</td>';
							$pageList .= '<td>' . $cpc . '</td>';
							$pageList .= '<td>' . $item[5] . '</td>';
							$pageList .= '<td class="btnGender">남녀비율</td>';
							$pageList .= '<td class="btnAge">연령대</td>';
							$pageList .= "</tr>";
						}
					}
					
					$tableFoot = $this->porcGaTablePageFoot($today_data);
					
					$this->add('tablefoot', $tableFoot);
					$this->add('ajaxdata', $pageList);
					
				// Gender
				} else if($sort == 'gender_range') {
					
					
					$_age = $this->procGa($analytics, $site_id, $start_date, $end_date, "ga:sessions", "ga:userAgeBracket, ga:userGender", '', '', 100);	
					
					$totalAge = $_age->totalsForAllResults['ga:sessions'];
					$graphAgeGender = $this->procGaChartAgeGender($_age);
					
					$ghtml = $graphAgeGender['ghtml'];
					
					$this->add('ajaxdata', $ghtml);
				
				} 
				
				
			}
			
			/**
	         * @brief ajax
	         **/
	        function procGaAjaxSetUpdate() 
	        {
				$cache_time = Context::get('cache_time') > 0  ? Context::get('cache_time') : "";
				$page_cnt = Context::get('page_cnt') > 100 ? Context::get('page_cnt') : "";
				$cache_del = Context::get('cache_del');
				$uninstall = Context::get('uninstall');
				
				$result = array();
				
				if($cache_del)
				{
					$args = new stdClass;
					$args->data = "";
					$outputGa = executeQuery("ga.updateGa", $args);
					
				}	else if($uninstall){
					
					$mid =  Context::get('mid');
					
					// menu_item
					$oDB = &DB::getInstance();
					$sql = $oDB->_query(' delete FROM '.$oDB->prefix.'menu_item WHERE url = "'.$mid.'" ');
					
					// modules
					$sql = $oDB->_query(' delete FROM '.$oDB->prefix.'modules WHERE module = "ga" ');
					
					// Ga
					$sql = $oDB->_query(' DROP TABLE '.$oDB->prefix.'ga ');
					//$oDB->_fetch($sql);
					
					$result = "1";
						
				}	else {
					
					$args = new stdClass;
					$args->cache_time = $cache_time;
					$args->page_cnt = $page_cnt;
					$outputGa = executeQuery("ga.updateGa", $args);
					
					$result['cache_time'] = $cache_time;
					$result['page_cnt'] = $page_cnt;
				}	
				
				
				// return page
				$this->add('result', $result);
				
	        }
			
			function search2Array($products, $field, $value)
			{
			   foreach($products as $key => $product)
			   {
			      if ( $product[$field] === $value )
			         return $key;
			   }
			   return false;
			}
			
						
			function parseURL($url, $retdata=true)
			{
			    $url = substr($url,0,4)=='http'? $url: 'http://'.$url; //assume http if not supplied
			    if ($urldata = parse_url(str_replace('&amp;','&',$url))){
			        $path_parts = pathinfo($urldata['host']);
			        $tmp = explode('.',$urldata['host']); $n = count($tmp);
			        if ($n>=2){
			            if ($n==4 || ($n==3 && strlen($tmp[($n-2)])<=3)){
			                $urldata['domain'] = $tmp[($n-3)].".".$tmp[($n-2)].".".$tmp[($n-1)];
			                $urldata['tld'] = $tmp[($n-2)].".".$tmp[($n-1)]; //top-level domain
			                $urldata['root'] = $tmp[($n-3)]; //second-level domain
			                $urldata['subdomain'] = $n==4? $tmp[0]: ($n==3 && strlen($tmp[($n-2)])<=3)? $tmp[0]: '';
			            } else {
			                $urldata['domain'] = $tmp[($n-2)].".".$tmp[($n-1)];
			                $urldata['tld'] = $tmp[($n-1)];
			                $urldata['root'] = $tmp[($n-2)];
			                $urldata['subdomain'] = $n==3? $tmp[0]: '';
			            }
			        }
			        //$urldata['dirname'] = $path_parts['dirname'];
			        $urldata['basename'] = $path_parts['basename'];
			        $urldata['filename'] = $path_parts['filename'];
			        $urldata['extension'] = $path_parts['extension'];
			        $urldata['base'] = $urldata['scheme']."://".$urldata['host'];
			        $urldata['abs'] = (isset($urldata['path']) && strlen($urldata['path']))? $urldata['path']: '/';
			        $urldata['abs'] .= (isset($urldata['query']) && strlen($urldata['query']))? '?'.$urldata['query']: '';
			        //Set data
			        if ($retdata){
			            return $urldata;
			        } else {
			            $this->urldata = $urldata;
			            return true;
			        }
			    } else {
			        //invalid URL
			        return false;
			    }
			}
			
    }
?>
